'''All things gluttony.'''

from concepts.color import *
            
from move import *


class Consumption(Action):
    def __init__(self, person, good):
        super(Consumption, self).__init__(person)
        
        self._good     = good
        self._progress = 0.0
    
    def speed(self):
        return self.good().consumption_speed()
    
    def good(self):
        return self._good
    
    def progress(self):
        return self._progress
    
    def unit_consumed(self):
        self.good().consumed_by(self.person(), 1)
    
    def act(self):
        self._progress += self.speed()
        
        while self.progress() >= 1.0:
            self._progress -= 1.0
            self.unit_consumed()
            
            if self.good().number() <= 0:
                self.done()


class GoAndConsume(Plan):
    def __init__(self, person, good):
        super(GoAndConsume, self).__init__(person)
        
        self._good   = good
        self._route  = Route(person, good.place())
        self._action = Consumption(person, good)
    
    def color(self):
        return Color(255, 255, 0)
        
    def good(self):
        return self._good
    
    def route(self):
        return self._route
    
    def action(self):
        return self._action
    
    def next_action(self):
        action = self.route().next_action()
        
        if action is None:
            action = self.action()
            self._action = None
            
        return action

    def path(self):
        return self.route().path()
