'''The farming industry.'''

from river.building import *
from river.actions.jobs import *
from river.goods import *


class Farm(Building):
    def __init__(self, city, tile):
        super(Farm, self).__init__(city, tile, [Farming(self), Farming(self)])
    
    @classmethod
    def name(cls):
        return 'Farm'
        
    @classmethod
    def size(self):
        return 3
    
    @classmethod
    def cost(self):
        return [Wood(6)]
    
    @classmethod
    def color(self):
        return Color(192, 192, 0)


Building.add_type(Farm, 'industry')


class Farming(Job):
    def __init__(self, farm):
        super(Farming, self).__init__(farm)
    
    def title(self):
        return 'Farmer'
    
    def color(self):
        return Color(255, 255, 0)
    
    def work_done(self):
        mind = self.person().mind()
        body = self.person().body()
        
        self.person().city().create(self.person().tile(),
                                    Wheat(random.randint(body, mind + body) / 2))
    
    def work_speed(self):
        return 0.004
    
    
class Wheat(Food):
    @classmethod
    def name(self):
        return ('Wheat', 'Wheat')
    
    @classmethod
    def color(self):
        return Color(255, 255, 0)
    
    @classmethod
    def nutrional_value(self):
        return 0.1

    @classmethod
    def consumption_speed(self):
        return 0.05
