'''The logging industry.'''

from river.building import *
from river.actions.jobs import *
from river.goods import *
from river.terrain import *


class Sawmill(Building):
    def __init__(self, city, tile):
        super(Sawmill, self).__init__(city, tile, [Woodcutting(self)])
    
    @classmethod
    def name(cls):
        return 'Sawmill'
        
    @classmethod
    def size(self):
        return 2
    
    @classmethod
    def color(self):
        return Color(192, 128, 0)
    
    @classmethod
    def cost(self):
        return [Wood(2)]
    
    @classmethod
    def built_on(self):
        return Forest


Building.add_type(Sawmill, 'industry')


class Woodcutting(Job):
    def __init__(self, sawmill):
        super(Woodcutting, self).__init__(sawmill)
    
    def title(self):
        return 'Lumberjack'
    
    def color(self):
        return Color(128, 96, 0)
    
    def work_done(self):
        body = self.person().body()
        
        self.person().city().create(self.person().tile(),
                                    Wood(random.randint(body / 4, body/ 2)))
    
    def work_speed(self):
        return 0.005
