'''The storage industry.'''

from river.building import *
from river.actions.jobs import *
from river.goods import *


class Storage(Building):
    def __init__(self, city, tile):
        super(Storage, self).__init__(city, tile, [Collecting(self),
                                                   Collecting(self),
                                                   Collecting(self)])
    
    @classmethod
    def name(cls):
        return 'Storage'
        
    @classmethod
    def size(self):
        return 3
    
    @classmethod
    def cost(self):
        return [Wood(7)]
    
    @classmethod
    def color(self):
        return Color(192, 192, 255)


Building.add_type(Storage, 'distribution')


class Collecting(Job):
    def __init__(self, storage):
        super(Collecting, self).__init__(storage)
        
    def title(self):
        return 'Collector'
    
    def color(self):
        return Color(128, 128, 255)
    
    def plan(self):
        def unstored(x):
            building = self.person().city().building_on(x.place())
            
            return building is None or building.__class__ is not Storage
        
        resource = self.person().claim_resource(self.person().body(), unstored)
        
        return MoveResource(self.person(), resource, self)
