'''All terrain in River.'''

from concepts.color import *


class TerrainType(object):
    def color(self):
        return Color(255, 0, 0)

    def difficulty(self):
        return None
    
    def is_passable(self):
        return (self.difficulty() is not None)
    
    def __str__(self):
        return self.__class__.__name__

    
class Grass(TerrainType):
    def color(self):
        return Color(0, 156, 64)

    def difficulty(self):
        return 0.75
    

class Forest(TerrainType):
    def color(self):
        return Color(0, 84, 32)

    def difficulty(self):
        return 2
    
    
class River(TerrainType):
    def color(self):
        return Color(0, 32, 164)

    def difficulty(self):
        return 5


class Outside(TerrainType):
    def color(self):
        return Color(0, 0, 0)

    def is_land(self):
        return False

    def difficulty(self):
        return None
