'''Textured surfaces.'''

from pygame import Surface

from concepts.color import *


class Texture(Surface):
    def __init__(self, extent, color):
        super(Texture, self).__init__(extent.tuple())

        self._extent = extent
        self._color  = color
        
        self.fill()
        
    def extent(self):
        return self._extent
    
    def color(self):
        return self._color
    
    def random_color(self):
        return self.color().shifted_randomly(0.2)
    
    def fill(self):
        for x in range(self.extent().x()):
            for y in range(self.extent().y()):
                self.set_at((x, y), self.random_color().tuple())
                
    def sized(self, extent):
        target = Surface(extent.tuple())
        
        for x in range(0, extent.x(), self.extent().x()):
            for y in range(0, extent.y(), self.extent().y()):
                target.blit(self, (x, y))
        
        return target
